Rem This File creates load and exec files, launch parallel loads, create indexes and launch parallel execs for the RF1 stored procedure

REM %SETUP_DIR%\CMD_RFs\cmd\RFs\RF1_preCreate.cmd 0 %RUN_ID% RF1_PC %INSERT_PARALLELISM%  %INSERT_EXECUTIONS% %BATCH_SIZE% REM %RF_FLATFILE_DIR% %TABLE_LOAD_PARALLELISM% %FILES_PER_UPDATE_SET%
ECHO STARTPRECREATE

@setlocal ENABLEDELAYEDEXPANSION

REM RF stream num
set TPCH_RF_STREAM_NUM=%1

REM output dir 
set TPCH_RUN_NUM=%2

REM Master log comment 
set TPCH_COMMENT_STR=%3

set TPCH_NUM_RF_EXEC_STREAMS=%4
set TPCH_NUM_RF_EXEC_TOTAL=%5
set TPCH_RF_EXEC_BATCH_SIZE=%6
set TPCH_UF_DIR=%7
set TPCH_NUM_RF_LOAD_STREAMS=%8
set TPCH_NUM_RF_LOAD_FILES=%9

set TPCH_AUTOMATION_PATH=%TPCH_KIT_DIR%\Setup\CMD_RFs

REM set TPCH_AUTOMATION_CMD_PATH=%TPCH_AUTOMATION_PATH%\cmd
REM set TPCH_AUTOMATION_SQL=%TPCH_AUTOMATION_PATH%\sql
REM set TPCH_AUTOMATION_CONFIG=%TPCH_AUTOMATION_PATH%\config
REM set TPCH_AUTOMATION_EXEC=%TPCH_AUTOMATION_PATH%\execs
REM set TPCH_MASTERLOG_NAME=MasterLog.txt
REM set TPCH_SQL_DIR=%systemdrive%\Program Files\Microsoft SQL Server\SQL14_Prerelease\12.0.1800.103
REM set TPCH_SQL_LOG_DIR=%systemdrive%\Program Files\Microsoft SQL Server\SQL14_Prerelease\12.0.1800.103
REM set TPCH_SQL_START_COMMAND_LINE =-c -E -x -T 834 -T 2312 -T 9493
REM set TPCH_SQL_SHELL=sqlcmd -S . -E -I -b -w 65535 -l 60 -y 0
REM set TPCH_EXEC_WINDOW_COLOR=9F

set TPCH_OUTPUT_DIR=%TPCH_OUTPUT_DIR_PREFIX%\%TPCH_RUN_NUM%
if not exist %TPCH_OUTPUT_DIR% md %TPCH_OUTPUT_DIR%
set TPCH_MASTERLOG_FILE=%TPCH_OUTPUT_DIR%\%TPCH_MASTERLOG_NAME%

pushd %TPCH_OUTPUT_DIR%
  
REM create tables and indexes

copy %TPCH_AUTOMATION_SQL%\RF_templ\Create_RF1_Tables.sql 
echo Create_RF1_Tables.sql > create_tables_RF1_%TPCH_RF_STREAM_NUM%.txt

REM copy %TPCH_AUTOMATION_SQL%\RF_templ\Drop_RF1_Tables.sql
REM echo Drop_RF1_Tables.sql > drop_tables_RF1_%TPCH_RF_STREAM_NUM%.txt


copy %TPCH_AUTOMATION_SQL%\RF_templ\Create_RF1_Indices.sql 
echo Create_RF1_Indices.sql > create_indices_RF1_%TPCH_RF_STREAM_NUM%.txt


REM create load files

set /A LOCAL_CURR_STREAM = 1
:outerLoopLoadCreate

	set /A LOCAL_CURR_LOAD = %LOCAL_CURR_STREAM%
	if exist (RF1_Load_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt) del RF1_Load_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt

	:innerLoopLoadCreate
	
	REM create load file	
	set SET_FILE_NUM=%LOCAL_CURR_LOAD% 

	echo :setvar ffLoc %TPCH_UF_DIR% 					> load_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_LOAD%.sql
	echo :setvar partNo %LOCAL_CURR_LOAD% 					>> load_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_LOAD%.sql
	type %TPCH_AUTOMATION_SQL%\RF_templ\Load_RF1_tmpl.sql 			>> load_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_LOAD%.sql

	REM add it to load file list 
	echo load_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_LOAD%.sql >> RF1_Load_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt

	set /A LOCAL_CURR_LOAD = %LOCAL_CURR_LOAD% + %TPCH_NUM_RF_LOAD_STREAMS%
	if %LOCAL_CURR_LOAD% LEQ %TPCH_NUM_RF_LOAD_FILES% goto innerLoopLoadCreate


set /A LOCAL_CURR_STREAM = %LOCAL_CURR_STREAM% + 1
if %LOCAL_CURR_STREAM% LEQ %TPCH_NUM_RF_LOAD_STREAMS% goto outerLoopLoadCreate


REM create exec files

set /A LOCAL_CURR_STREAM = 1
:outerLoopExecCreate

	set /A LOCAL_CURR_EXEC = %LOCAL_CURR_STREAM%
	if exist (RF1_Execute_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt) del RF1_Execute_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt

	:innerLoopExecCreate
	
	REM create exec file	

	echo :setvar currExec %LOCAL_CURR_EXEC%			> exec_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	echo :setvar batchSize %TPCH_RF_EXEC_BATCH_SIZE%		>> exec_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	echo :setvar numParallelExecs %TPCH_NUM_RF_EXEC_STREAMS%	>> exec_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	echo :setvar totalExecs %TPCH_NUM_RF_EXEC_TOTAL%		>> exec_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql
	type %TPCH_AUTOMATION_SQL%\RF_templ\Execute_RF1_tmpl.sql>> exec_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql

	REM add it to exec file list 
	echo exec_RF1_input.%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_EXEC%.sql >> RF1_Execute_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt

	set /A LOCAL_CURR_EXEC = %LOCAL_CURR_EXEC% + %TPCH_NUM_RF_EXEC_STREAMS%
	if %LOCAL_CURR_EXEC% LEQ %TPCH_NUM_RF_EXEC_TOTAL% goto innerLoopExecCreate

set /A LOCAL_CURR_STREAM = %LOCAL_CURR_STREAM% + 1
if %LOCAL_CURR_STREAM% LEQ %TPCH_NUM_RF_EXEC_STREAMS% goto outerLoopExecCreate


endlocal
