VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cStepIds"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'  FILE:        cStepIds.cls
'               Microsoft TPC-H Kit Ver. 2.7.0-1005
'               Copyright Microsoft, 2008
'               All Rights Reserved
'
'
'  PURPOSE:     Stores an array of StepId structures. Used by Tools when
'               importing or exporting a workspace.
'  Contact:     Reshma Tharamal (reshmat@microsoft.com)
'
Option Explicit
Private Const mstrModuleName As String = "cStepIds."

Private lIdCount As Long
Private larrStepIds() As StepId
Private cStepSeq As cSequence

Private Type StepId
    OldId As Long
    NewId As Long
End Type
Public Sub AddStepId(lStepId As Long)
    
    lIdCount = lIdCount + 1
    ReDim Preserve larrStepIds(lIdCount)
    larrStepIds(lIdCount - 1).OldId = lStepId
    larrStepIds(lIdCount - 1).NewId = cStepSeq.Identifier

End Sub
Public Function NewId(lOldStepId As Long) As Long
    
    Dim lTemp As Long
    
    If lOldStepId = 0 Then
        NewId = 0
    Else
        For lTemp = 0 To lIdCount - 1
            If larrStepIds(lTemp).OldId = lOldStepId Then
                NewId = larrStepIds(lTemp).NewId
                Exit Function
            End If
        Next lTemp
        
        On Error GoTo 0
        Err.Raise vbObjectError + errQueryFailed, mstrModuleName & "NewStepId", _
                LoadResString(errQueryFailed)
    End If

End Function


Public Property Set StepDB(vdata As Database)
    Set cStepSeq.IdDatabase = vdata
    cStepSeq.IdentifierColumn = "step_id"
End Property

Private Sub Class_Initialize()
    
    lIdCount = 0
    Set cStepSeq = New cSequence
    
End Sub


Private Sub Class_Terminate()
    ReDim larrStepIds(0)
    lIdCount = 0
    
    Set cStepSeq = Nothing
End Sub


